(function () {
    'use strict';

    var cssBootstrap = function (options) {
        this.init(options);
    };

    cssBootstrap.VERSION = '1.0.0';
    cssBootstrap.DEFAULTS = { 
  			showDebug : false,
  			deleteButtonSelector: "button[name='deinstallieren']",
  			cssPluginId: new Array(),
  			cssPluginNames: new Array(),
  			pluginData: new Array(),
  			confirmTemplate: '\
  				<div class="modal fade" id="cssPlugin_confirmation_modal" data-keyboard="false" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<form role="form" method="post" action="category_delete" id="delete_PluginData">\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-danger confirmYes" >Ja ich m&ouml;chte</button>\
			    					<button type="button" class="btn btn-primary confirmNo" data-dismiss="modal">Nein ich m&ouml;chte nicht</button>\
  									<button type="button" class="btn btn-warning confirmCancel" data-dismiss="modal">Abbrechen</button>\
			    				</div>\
			    			</form>\
			    		</div>\
			    	</div>\
			    </div>\
			',
  			noticeTemplate: '\
  				<div class="modal fade " id="css_notice_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
    };
    cssBootstrap.prototype = {

        constructor: cssBootstrap,

        init: function (options) {
            this.options = $.extend({}, cssBootstrap.DEFAULTS, options);
            var that = this;
        },

        register: function(options) {
        	var that=this;
        	this.debug("function register started");
        	this.initDeleteButton();
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

        initDeleteButton: function() {
        	var that = this;
        	var useConfirm=false;
        	var tableCheckClasses='';
        	var classNames = new Array();
        	$("#content").on("click", that.options.deleteButtonSelector, function(e) {
        		that.debug("delete Button (" + that.options.deleteButtonSelector + ") is clicked");
        		var pluginList = that.getPluginId();
        		for(var pluginListCounter=0; pluginListCounter<pluginList.length; pluginListCounter++) {
        			that.debug("Prüfe Input " + "input#plugin-check-" + pluginList[pluginListCounter]);
        			if($("input#plugin-check-" + pluginList[pluginListCounter] ).is(":checked")) {
        				that.debug("habe ein aktiviertes css Plugin gefunden!");	
        				useConfirm=true;
        			}
        		}
        		if( useConfirm && !$(this).hasClass("css-confirmed")) {
        			e.preventDefault();
        			e.stopPropagation();
      				that.openModalConfirmation(this,"alert alert-danger", "Achtung", "Sind Sie sicher, dass Sie die ausgew&auml;hlten Plugins von css-umsetzung deinstallieren m&ouml;chten?","css-confirmed");
        			return;	
      			} 
        		if(useConfirm && $(this).hasClass("css-confirmed")) {
        			var cssPlugins = that.getPlugins();
	        		for(var pluginListCounter=0; pluginListCounter<pluginList.length; pluginListCounter++) {
	        			if(!$("input#plugin-check-" + pluginList[pluginListCounter] ).is(":checked")) {
	        				continue;
	        			}
	        			classNames.push("table-check-" + pluginList[pluginListCounter]);
	        			if(!$(this).hasClass("table-check-" + pluginList[pluginListCounter] ))	{
	          			e.preventDefault();
	          			e.stopPropagation();
	          			$(that.options.deleteButtonSelector).addClass("table-check-" + pluginList[pluginListCounter])
	          			var func = function() { $(that.options.deleteButtonSelector).closest("form").prepend("<input type='hidden' class='css-delete-tables' name='css-delete-tables-from-" + cssPlugins[pluginListCounter].pluginID + "' value='true'>" + "<input type='hidden' class='css-delete-tables' name='css-delete-tables-" + pluginList[pluginListCounter] + "' value='true'>"); };
	          			var noFunc = function(el, selector, titel,content, confirmSelector) { that.debug(el);  that.debug(confirmSelector); $(el).addClass(confirmSelector).trigger("click"); };
	          			var cancelFunc = function(el,confirmSelector) { $(el).removeClass('css-confirmed ' + classNames.join(" ")); $("input.css-delete-tables").remove();  };
	          			that.debug(cssPlugins[pluginListCounter]);
	          			that.openModalConfirmation(
	          					this,
	          					"alert alert-info", 
	          					"SQL Datenbank Konfiguration " + cssPlugins[pluginListCounter].pluginName, 
	          					"<p>M&ouml;chten Sie auch die Datenbank Eintr&auml;ge von dem Plugin <strong style='white-space:nowrap;' > " + cssPlugins[pluginListCounter].pluginName + " </strong> l&ouml;schen?</p>" + cssPlugins[pluginListCounter].pluginNotice, 
	          					"", 
	          					func,
	          					noFunc,
	          					cancelFunc
	          			);
	          			return;	
	        			}
	        		}
        		}
        });
    },
    
    hasPluginId: function(id) {
    	if($.inArray(id,$.cssB.getPluginId())>=0) {
    		return true;
    	}
    },
    
    getPluginId: function() {
    	return this.options.cssPluginId;
    },

    getPlugins: function() {
    	return this.options.pluginData;
    },

    addPlugin: function(pluginId, pluginName, pluginID, pluginNotice) {
    	var that = this;
    	that.debug(pluginNotice);
    	this.options.pluginData.push({
    			pluginId: pluginId,
    			pluginName: pluginName,
    			pluginID: pluginID,
    			pluginNotice:pluginNotice
    	});
    },
    
    getPluginNames: function() {
    	return this.options.cssPluginNames;
    },
    
        addPluginId: function(id,name,pluginID,notice) {
        	this.debug("add  Plugin ID " + id);	
        	this.options.cssPluginId.push(id);
        	this.addPlugin(id,name,pluginID,notice);
        },
        
    		openModalConfirmation: function (el, selector, titel,content, confirmSelector,func,noFunc,cancelFunc ) {
    			var that = this;
  				if(typeof confirmSelector !== 'undefined') {
  					var confirmSelector = "css-confirmed";
  				}
    			$("#cssPlugin_confirmation_modal").remove();
    			$(".modal-backdrop.fade.in").remove();
    			$("body").append(this.options.confirmTemplate);
    			$("#cssPlugin_confirmation_modal .modal-content").addClass(selector);
    			$("#cssPlugin_confirmation_modal .modal-title").html(titel);
    			$("#cssPlugin_confirmation_modal .modal-body").html(content);
    			
    			$("#cssPlugin_confirmation_modal .confirmCancel").on("click", function() {
	  				if(typeof cancelFunc !== 'undefined') {
	  					that.debug("starte die angegebene Funktion() für das Abbrechen");
	  					cancelFunc(el, selector, titel,content, confirmSelector,func);
	  				}
    			});
    			
    			$("#cssPlugin_confirmation_modal .confirmNo").on("click", function() {
	  				if(typeof noFunc !== 'undefined') {
	  					that.debug("starte die angegebene Funktion() für den NEIN Button");
	  					noFunc(el, selector, titel,content, confirmSelector,func);
	  				}
    			});
    			
    			$("#cssPlugin_confirmation_modal .confirmYes").on("click", function() {
	   				$("#cssPlugin_confirmation_modal").modal("hide");
	  				if(typeof func !== 'undefined') {
	  					that.debug("starte die angegebene Funktion()");
	  					func();
	  				}
	  				$(el).addClass(confirmSelector).trigger("click");
    			});
    			$("#cssPlugin_confirmation_modal").modal({backdrop: 'static', keyboard: false});
    		},
        
    		openModalNotice: function (el, selector, titel,content) {
    			$("#css_notice_modal").remove();
    			$("body").append(this.options.noticeTemplate);
    			if(selector) $("#css_shipping_modal .modal-content").addClass(selector);
    			$("#css_notice_modal .modal-title").html(titel);
    			$("#css_notice_modal .modal-body").html(content);
    			$("#css_notice_modal").modal("show");
    		},

    		post_data: function (url, data) {
    			var that = this;
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
//		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							that.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							that.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							that.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
            $("body").trigger('contentChanged');
					},
					error: function() {
						that.debug('something is wrong....anything buggy?');
					},
					complete: function() {
							
					}
			});
		},
   };

    $.cssBoot = function(options) {
    	$.cssB = new cssBootstrap(options);
    	$.cssB.register();
    	return $.cssB;
    };
})(jQuery);

$(document).ready(function () {
	$.cssBoot({
		showDebug : false,
	});
});

