(function () {
    'use strict';

    var cssTaxZoneAdminClass = function (options) {
        this.init(options);
    };

    cssTaxZoneAdminClass.VERSION = '1.0.1';
    cssTaxZoneAdminClass.DEFAULTS = { 
  			showDebug : true
    };

    cssTaxZoneAdminClass.prototype = {

        constructor: cssTaxZoneAdminClass,

        init: function (options) {
            this.options = $.extend({}, cssTaxZoneAdminClass.DEFAULTS, options);
            var that = this;
            that.initFlagButtons();
            that.initGetGeoIP();
        },

        register: function(options) {
        	var that=this;
        	this.debug("ich starte cssTaxZoneAdminClass.VERSION " +  this.__proto__.constructor.VERSION);
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

        _set: function(key,value) {
        	this.options.key = value;
        },
    		

        initGetGeoIP: function() {
        	var that=this;
        	that.debug("initialisiere geoIPImport");
        	$(document).on("click", ".geoIPImport", function() {
          	that.debug("starte geoIPImport");

      			var url = location.href;
      			var data = data = 'jtl_token=' + $(this).closest('form').find('.jtl_token').val() + '&cssAdminConfigAction=getGeoIP&token=' + $(this).closest('form').find('#maxMindUserKey').val();
      			that.post_data(url,data);		
        	});
        },
        
        initFlagButtons: function () {
        	var that = this;
        	$(document).on("click" , ".css-flag-button", function(e) {
        		e.preventDefault();
        		var data = 'jtl_token=' + $(this).closest('form').find('.jtl_token').val() + '&cssAdminConfigAction=' + 'showFlags&element=' +  $(this).attr("id");
        		that.post_data($(this).closest('form').attr('action'),data);
        	});
        },

        post_data: function (url, data) {
        	console.log(data);
        	var that = this;	
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							that.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							that.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							that.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
					},
					error: function() {
						that.debug('something is wrong....anything buggy?');
					},
					complete: function() {
					}
			});
		},
   };

    $.cssTaxZoneAdmin = function(options) {
    	console.log("starte cssTaxZone");
    	$.cssTaxZoneAdmin = new cssTaxZoneAdminClass(options);
    	$.cssTaxZoneAdmin.register();
    	return $.cssTaxZoneAdmin;
    };
    $.cssTaxZoneAdmin();
})(jQuery);


